<!-- 
This README describes the package. If you publish this package to pub.dev,
this README's contents appear on the landing page for your package.

For information about how to write a good package README, see the guide for
[writing package pages](https://dart.dev/guides/libraries/writing-package-pages). 

For general information about developing packages, see the Dart guide for
[creating packages](https://dart.dev/guides/libraries/create-library-packages)
and the Flutter guide for
[developing packages and plugins](https://flutter.dev/developing-packages). 
-->

Dart SDK for some of Twilio Conversation REST APIs,
(Conversations,participants,and messages specifically)

## Features

Create,Fetch,Read Multiple,Update,Delete for Conversations,participants,and messages.

## Getting started

Step 1:register a twilio account, get account SID,auth token
Step 2:flutter pub add twilio_conversation
Step 3:In flutter use TwiConvApi(acc_sid,auth_token),
TwiPartApi(acc_sid,auth_token,conversation_sid),
TwiMesgApi(acc_sid,auth_token,conversation_sid) to get data

## Usage

Create a Conversation
```dart
final conversation=TwiConvApi(acc_sid,auth_token).createConv();
```

Create Users for the conversation
```dart
final partApi=TwiPartApi(acc_sid,auth_token,conversation.sid);
final chatUser=partApi.createPart(uid:"test id");
final twilioUser=partApi.createPart(address: "+19998887777",poxyAddr: "+1333222111");
final otherPhoneUser=partApi.createPart(address: "+19998886666",);
```

Create a message
```dart
final message=TwiConvApi(acc_sid,auth_token,conversation.sid)
.createMesg(author: "test id",body: "hi");
```

## Additional information

for more information,please refer to official API
https://www.twilio.com/docs/conversations/api/conversation-resource
