import 'dart:convert';

import 'package:twilio_conversation_rest/apis/twi_conversation_apis.dart';
import 'package:twilio_conversation_rest/models/twi_conv.dart';

import '../models/utils/multi_data.dart';

class TwiConvApi extends TwiConversationsApis<TwiConv>{
  TwiConvApi(super.accSid, super.authToken,{super.conversationServiceSID});

  @override
  String get apiPath => "";


  Future<TwiConv> createConv({String? name,String? uid,Map<String,dynamic>?attributes})async {
    return await super.create({
      if(name!=null)"FriendlyName":name,
      if(uid!=null)"UniqueName":uid,
      if(attributes!=null)"Attributes":json.encode(attributes)
    });
  }

  Future<TwiConv> updateConv(String sid,{String? name,String? uid,String?state,
    Map<String,dynamic>?attributes})async {
    return await super.update(sid,{
      if(name!=null)"FriendlyName":name,
      if(uid!=null)"UniqueName":uid,
      if(state!=null)"State":state,
      if(attributes!=null)"Attributes":json.encode(attributes)
    });
  }

  @override
  Future<MultiData<TwiConv>> readMultiConv({int? limit,int? pageSize,int? pageNumber})async {
    return await super.readMulti({
      if(limit!=null)"Limit":limit,
      if(pageSize!=null)"PageSize":pageSize,
      if(pageNumber!=null)"PageNumber":pageNumber,
    });
  }
}