import 'dart:convert';

import 'package:twilio_conversation_rest/apis/twi_conversation_apis.dart';
import 'package:twilio_conversation_rest/models/utils/multi_data.dart';
import 'package:twilio_conversation_rest/models/twi_mesg.dart';

class TwiMesgApi extends TwiConversationsApis<TwiMesg>{
  String convSid;
  TwiMesgApi(super.accSid, super.authToken,this.convSid,{super.conversationServiceSID});

  @override
  String get apiPath => "/$convSid/Messages";

  Future<TwiMesg> createMesg({String? author,Map<String,dynamic>?attributes,String? body})async {
    return await super.create({
      if(author!=null)"Author":author,
      if(attributes!=null)"Attributes":json.encode(attributes),
      if(body!=null)"Body":body,
    });
  }

  Future<TwiMesg> updateMesg(String sid,{String? author,Map<String,dynamic>?attributes,String? body})async {
    return await super.update(sid,{
      if(author!=null)"Author":author,
      if(attributes!=null)"Attributes":json.encode(attributes),
      if(body!=null)"Body":body,
    });
  }

  @override
  Future<MultiData<TwiMesg>> readMultiMesg({int? limit,bool desc=true,int? pageSize,int? pageNumber}) {
    return super.readMulti({
      if(limit!=null)"Limit":limit,
      if(desc)"Order":"desc",//"asc"
      if(pageSize!=null)"PageSize":pageSize,
      if(pageNumber!=null)"PageNumber":pageNumber,
    });
  }
}