import 'dart:convert';

import 'package:twilio_conversation_rest/apis/twi_conversation_apis.dart';
import 'package:twilio_conversation_rest/models/twi_part.dart';

import '../models/utils/multi_data.dart';

class TwiPartApi extends TwiConversationsApis<TwiPart>{
  String convSid;
  TwiPartApi(super.accSid, super.authToken,this.convSid,{super.conversationServiceSID});

  @override
  String get apiPath => "/$convSid/Participants";


  Future<TwiPart> createPart({String? uid,Map<String,dynamic>?attributes,String? address,
    String? poxyAddr,String? projectedAddr})async {
    return await super.create({
      if(uid!=null)"Identity":uid,
      if(attributes!=null)"Attributes":json.encode(attributes),
      if(address!=null)"MessagingBinding.Address":address,
      if(poxyAddr!=null)"MessagingBinding.ProxyAddress":poxyAddr,
      if(projectedAddr!=null)"MessagingBinding.ProjectedAddress":projectedAddr,
    });
  }

  Future<TwiPart> updatePart(String sid,{String? uid,Map<String,dynamic>?attributes,String? address,
    String? poxyAddr,String? projectedAddr})async {
    return await super.update(sid,{
      if(uid!=null)"Identity":uid,
      if(attributes!=null)"Attributes":json.encode(attributes),
      if(address!=null)"MessagingBinding.Address":address,
      if(poxyAddr!=null)"MessagingBinding.ProxyAddress":poxyAddr,
      if(projectedAddr!=null)"MessagingBinding.ProjectedAddress":projectedAddr,
    });
  }

  @override
  Future<MultiData<TwiPart>> readMultiPart({int? limit,int? pageSize,int? pageNumber}) {
    return super.readMulti({
      if(limit!=null)"Limit":limit,
      if(pageSize!=null)"PageSize":pageSize,
      if(pageNumber!=null)"PageNumber":pageNumber,
    });
  }
}