
import 'package:flutter/foundation.dart';
import 'package:freezed_annotation/freezed_annotation.dart';

import 'states/conv_state.dart';

part 'conv_links.freezed.dart';
part 'conv_links.g.dart';

@freezed
abstract class ConvLinks with _$ConvLinks{

  const ConvLinks._();
  const factory ConvLinks({
    String? participants,
    String? messages,
    String? webhooks,
    @JsonKey(name: "delivery_receipts")String? deliveryReceipts,
  })=_ConvLinks;

  factory ConvLinks.fromJson(Map<String,dynamic>json)=> _$ConvLinksFromJson(json);

  static fJson(Map<String,dynamic> j)=>ConvLinks.fromJson(j);
  static tJson(ConvLinks j)=>j.toJson();
}