
import 'package:flutter/foundation.dart';
import 'package:freezed_annotation/freezed_annotation.dart';

import 'states/conv_state.dart';
import 'states/delivery_state.dart';

part 'msg_delivery.freezed.dart';
part 'msg_delivery.g.dart';

@freezed
abstract class MsgDelivery with _$MsgDelivery{

  const MsgDelivery._();
  const factory MsgDelivery({
    required int total,
    required DeliState sent,
    required DeliState delivered,
    required DeliState read,
    required DeliState failed,
    required DeliState undelivered,
  })=_MsgDelivery;

  factory MsgDelivery.fromJson(Map<String,dynamic>json)=> _$MsgDeliveryFromJson(json);

  static fJson(Map<String,dynamic>? j)=>j==null?null:MsgDelivery.fromJson(j);
  static tJson(MsgDelivery? j)=>j?.toJson();
}