
import 'dart:convert';

import 'package:flutter/foundation.dart';
import 'package:freezed_annotation/freezed_annotation.dart';
import 'package:twilio_conversation_rest/util/map_converter.dart';

import 'conv_links.dart';
import 'states/conv_state.dart';

part 'twi_conv.freezed.dart';
part 'twi_conv.g.dart';

@freezed
abstract class TwiConv with _$TwiConv{

  const TwiConv._();
  const factory TwiConv({
    required String sid,
    @JsonKey(name: "chat_service_sid")required String chatSvSid,
    @JsonKey(name: "messaging_service_sid")String? msgSvSid,
    @JsonKey(name: "friendly_name")String? fdName,
    @JsonKey(name: "unique_name")String? unqName,
    @JsonKey(fromJson: str2map,toJson: map2str)required Map<String,String> attributes,
    ConvState? state,
    @JsonKey(name: "date_created")required DateTime dateCreated,
    @JsonKey(name: "date_updated")required DateTime dateUpdated,
    Map<String,String>? timers,
    required String url,
    @JsonKey(fromJson: ConvLinks.fJson,toJson: ConvLinks.tJson)required ConvLinks links,
    @Default({})Map<String,String> bindings,
  })=_TwiConv;

  factory TwiConv.fromJson(Map<String,dynamic>json)=> _$TwiConvFromJson(json);

  // factory Entry.fromDoc(DocumentSnapshot<Map<String,dynamic>> ds){
  //   return Entry.fromJson(ds.data()!).copyWith(id: ds.id);
  // }
}