
import 'package:flutter/foundation.dart';
import 'package:freezed_annotation/freezed_annotation.dart';
import 'package:twilio_conversation_rest/models/msg_delivery.dart';

import '../util/map_converter.dart';
import 'conv_links.dart';


part 'twi_mesg.freezed.dart';
part 'twi_mesg.g.dart';

@freezed
abstract class TwiMesg with _$TwiMesg{

  const TwiMesg._();
  const factory TwiMesg({
    required String sid,
    @JsonKey(name: "conversation_sid")required String convSid,
    @JsonKey(name: "participant_sid")String? partSid,
    required String body,
    required int index,
    required String author,
    List<Map<String,dynamic>>? media,
    @JsonKey(fromJson: str2map,toJson: map2str)required Map<String,String> attributes,
    @JsonKey(name: "date_created")required DateTime dateCreated,
    @JsonKey(name: "date_updated")required DateTime dateUpdated,
    @JsonKey(fromJson: MsgDelivery.fJson,toJson: MsgDelivery.tJson)MsgDelivery? delivery,
    required String url,
    @JsonKey(fromJson: ConvLinks.fJson,toJson: ConvLinks.tJson)required ConvLinks links,
  })=_TwiMesg;

  factory TwiMesg.fromJson(Map<String,dynamic>json)=> _$TwiMesgFromJson(json);

  // factory Entry.fromDoc(DocumentSnapshot<Map<String,dynamic>> ds){
  //   return Entry.fromJson(ds.data()!).copyWith(id: ds.id);
  // }
}