
import 'package:flutter/foundation.dart';
import 'package:freezed_annotation/freezed_annotation.dart';

import '../util/map_converter.dart';


part 'twi_part.freezed.dart';
part 'twi_part.g.dart';

@freezed
abstract class TwiPart with _$TwiPart{

  const TwiPart._();
  const factory TwiPart({
    required String sid,
    @JsonKey(name: "conversation_sid")required String convSid,
    @Default("System Bot") String identity,
    @JsonKey(fromJson: str2map,toJson: map2str)required Map<String,String> attributes,
    @JsonKey(name: "messaging_binding")Map<String,String>? msgBinding,
    @JsonKey(name: "role_sid")required String roleSid,
    @JsonKey(name: "date_created")required DateTime dateCreated,
    @JsonKey(name: "date_updated")required DateTime dateUpdated,
    required String url,
    @JsonKey(name: "last_read_message_index")int? lastReadIndex,
    @JsonKey(name: "last_read_timestamp")DateTime? lastReadTime,
  })=_TwiPart;

  factory TwiPart.fromJson(Map<String,dynamic>json)=> _$TwiPartFromJson(json);

  // factory Entry.fromDoc(DocumentSnapshot<Map<String,dynamic>> ds){
  //   return Entry.fromJson(ds.data()!).copyWith(id: ds.id);
  // }
}