import 'package:twilio_conversation_rest/models/twi_conv.dart';
import 'package:twilio_conversation_rest/models/twi_mesg.dart';
import 'package:twilio_conversation_rest/models/twi_part.dart';

class MultiData<T>{
  late List<T>content;
  late Map<String,dynamic> meta;
  get page=>meta["page"];
  get pageSize=>meta["page_size"];
  get firstPgUrl=>meta["first_page_url"];
  get prevPgUrl=>meta["previous_page_url"];
  get url=>meta["url"];
  get nextPgUrl=>meta["next_page_url"];
  get key=>meta["key"];
  MultiData(this.content,this.meta);
  MultiData.fromMap(Map<String,dynamic>m){
    meta=m["meta"];
    content=m[meta["key"]].map<T>((e) => returnT(e)).toList();
  }

  T returnT(Map<String,dynamic>d){
    print(d);
    if(T == TwiConv)return TwiConv.fromJson(d) as T;
    if(T == TwiPart)return TwiPart.fromJson(d) as T;
    if(T == TwiMesg)return TwiMesg.fromJson(d) as T;
    throw Exception("MultiData Error: unknown type from TwiConv,TwiPart,or TwiMesg");
  }
}